import { ResourceDefinition, ResourceRouteDefinition, UnthinkGeneratorBackend, UnthinkMiddleware, UnthinkRawMiddleware, UnthinkViewRenderer } from '@epandco/unthink-foundation/lib/core';
import { Application, RequestHandler, Router } from 'express';
export interface ExpressMiddleware extends UnthinkRawMiddleware, RequestHandler {
    __expressMiddleware: 'EXPRESS_MIDDLEWARE';
}
interface GeneratedRoute {
    prefix: string;
    router: Router;
}
interface GeneratedDefinition {
    path: string;
    router: Router;
}
export declare class UnthinkExpressGenerator implements UnthinkGeneratorBackend {
    private readonly app;
    private readonly viewRenderer;
    private readonly logLevel;
    constructor(app: Application, viewRenderer: UnthinkViewRenderer, logLevel: string);
    generate(resourceDefinitions: ResourceDefinition<UnthinkMiddleware>[]): void;
    generateRoute(resourceRouteDefinition: ResourceRouteDefinition<UnthinkMiddleware>, resourceMiddleware?: UnthinkMiddleware[]): GeneratedRoute;
    generateDefinition(resourceDefinition: ResourceDefinition<UnthinkMiddleware>): GeneratedDefinition[];
}
export {};
